#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    long long n,m;
    cin>>n>>m;
    long long a[n][m],b[n][m],c[n][m];
    for(int i=0;i<n;i++) for(int j=0;j<m;j++){cin>>a[i][j];c[i][j]=a[i][j];}
    for(int i=0;i<n;i++) for(int j=0;j<m;j++)
    {
        if(i==0) if(j==0);
        else a[i][j]+=a[i][j-1];
        else if(j==0) a[i][j]+=a[i-1][j];
        else a[i][j]+=min(a[i-1][j],a[i][j-1]);
        b[i][j]=a[i][j];
    }
    int q;
    cin>>q;
    for(int k=0;k<q;k++)
    {
        long long x,y;
        cin>>x>>y;
        for(int i=x-1;i<n;i++) for(int j=y-1;j<m;j++)
        {
            a[i][j]=c[i][j];
            if(i==x-1) if(j==y-1);
            else a[i][j]+=a[i-1][j];
            else if(j==y-1) a[i][j]+=a[i][j-1];
            else a[i][j]+=min(a[i-1][j],a[i][j-1]);
        }
        cout<<a[n-1][m-1]<<"\n";
        for(int i=x-1;i<n;i++)
            for(int j=y-1;j<m;j++)
        {
            a[i][j]=b[i][j];
        }
    }
}